// DlgMem.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "DlgMem.h"

#include "MainFrm.h"
#include "DlgMemDoc.h"
#include "DlgMemView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgMemApp

BEGIN_MESSAGE_MAP(CDlgMemApp, CWinApp)
	//{{AFX_MSG_MAP(CDlgMemApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgMemApp construction

CDlgMemApp::CDlgMemApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CDlgMemApp object

CDlgMemApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CDlgMemApp initialization

BOOL CDlgMemApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	LoadStdProfileSettings(0);  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CDlgMemDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CDlgMemView));
	AddDocTemplate(pDocTemplate);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The one and only window has been initialized, so show and update it.
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog members

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_LIST1, m_lbList);
	DDX_Control(pDX, IDC_SLIDER1, m_Slider);
	DDX_Control(pDX, IDC_COMBO1, m_cbCombo);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CDlgMemApp::OnAppAbout()
{
	m_AboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CDlgMemApp commands

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// Set up the dialog
	m_Slider.SetRange( 0, 100 );

	m_cbCombo.AddString( _T("Homer") );
	m_cbCombo.AddString( _T("Marge") );
	m_cbCombo.AddString( _T("Bart") );
	m_cbCombo.AddString( _T("Lisa") );
	m_cbCombo.AddString( _T("Maggie") );

	m_lbList.AddString( _T("Mr. Burns") );
	m_lbList.AddString( _T("Moe") );
	m_lbList.AddString( _T("Krusty the Klown") );
	m_lbList.AddString( _T("Reverend Lovejoy") );
	m_lbList.AddString( _T("Principal Skinner") );
	m_lbList.AddString( _T("Barney") );

	GetDlgItem( IDC_EDIT1 )->SetWindowText( _T("Type Text Here!") );

	// Attach the object, Restore the state
	m_Memory.Attach( this );
	m_Memory.RestoreState();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CAboutDlg::OnOK() 
{
	// Erase old memory
	m_Memory.ForgetState();

	// save each control's state
	m_Memory.SaveCheckBox( IDC_CHECK1 );	
	m_Memory.SaveCheckBox( IDC_CHECK2 );	
	m_Memory.SaveCheckBox( IDC_CHECK3 );	
	m_Memory.SaveRadioButtons( IDC_RADIO1 );	
	m_Memory.SaveComboBoxSelection( IDC_COMBO1 );	
	m_Memory.SaveListBoxSelection( IDC_LIST1 );	
	m_Memory.SaveEditBoxText( IDC_EDIT1 );	
	m_Memory.SaveSliderInfo( IDC_SLIDER1 );
	
	// default handling
	CDialog::OnOK();
}
