// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Snoop.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_COMMAND(IDM_ALWAYS_ON_TOP, OnAlwaysOnTop)
	ON_UPDATE_COMMAND_UI(IDM_ALWAYS_ON_TOP, OnUpdateAlwaysOnTop)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	m_bAlwaysOnTop = FALSE;
}

CMainFrame::~CMainFrame()
{
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	return CMDIFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnAlwaysOnTop() 
{
	m_bAlwaysOnTop = !m_bAlwaysOnTop ;
	SetWindowPos ((m_bAlwaysOnTop)?&CWnd::wndTopMost:&CWnd::wndNoTopMost,
					0, 0, 0, 0,
					SWP_NOACTIVATE | SWP_NOSIZE | SWP_NOMOVE);
}

void CMainFrame::OnUpdateAlwaysOnTop(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck((m_bAlwaysOnTop)?TRUE:FALSE);
}

void CMainFrame::OnDestroy() 
{
	SaveReg();
	CMDIFrameWnd::OnDestroy();
}

#define APP_GPI AfxGetApp()->GetProfileInt
#define APP_WPI AfxGetApp()->WriteProfileInt
#define APP_GPS AfxGetApp()->GetProfileString
#define APP_WPS AfxGetApp()->WriteProfileString

static char *szWindowPlacement = "WindowPlacement";

BOOL CMainFrame::LoadReg()
{
	m_bAlwaysOnTop = APP_GPI("Flags", "AlwaysOnTop", 0) ? TRUE : FALSE;

	WINDOWPLACEMENT wp;	
	wp.length = sizeof(WINDOWPLACEMENT);

	wp.flags = APP_GPI(szWindowPlacement, "flags", 0);
	wp.showCmd = APP_GPI(szWindowPlacement, "showCmd", 0);

	wp.ptMinPosition.x = APP_GPI(szWindowPlacement, "ptMinPosition.x", 0);
	wp.ptMinPosition.y = APP_GPI(szWindowPlacement, "ptMinPosition.y", 0);

	wp.ptMaxPosition.x = APP_GPI(szWindowPlacement, "ptMaxPosition.x", 0);
	wp.ptMaxPosition.y = APP_GPI(szWindowPlacement, "ptMaxPosition.y", 0);

	wp.rcNormalPosition.left = APP_GPI(szWindowPlacement, "rcNormalPosition.left", 0);
	wp.rcNormalPosition.right = APP_GPI(szWindowPlacement, "rcNormalPosition.right", 0);
	wp.rcNormalPosition.top = APP_GPI(szWindowPlacement, "rcNormalPosition.top", 0);
	wp.rcNormalPosition.bottom = APP_GPI(szWindowPlacement, "rcNormalPosition.bottom", 0);

	CRect rcScreen (0, 0,
		::GetSystemMetrics(SM_CXSCREEN),
		::GetSystemMetrics(SM_CYSCREEN));
	
	CRect rcIntersect;
	CRect rcNormal(wp.rcNormalPosition);

	if (m_bAlwaysOnTop)
	{
		m_bAlwaysOnTop = FALSE;
		SendMessage(WM_COMMAND, IDM_ALWAYS_ON_TOP);
		ASSERT(m_bAlwaysOnTop);
	}

	if (!rcNormal.IsRectEmpty() &&
		rcIntersect.IntersectRect(rcNormal, rcScreen))
	{
		SetWindowPlacement(&wp);
		return TRUE;
	}
	return FALSE;
}

void CMainFrame::SaveReg()
{
	APP_WPI("Flags", "AlwaysOnTop", m_bAlwaysOnTop?1:0);

	WINDOWPLACEMENT wp;	
	wp.length = sizeof(WINDOWPLACEMENT);
	GetWindowPlacement(&wp);

	APP_WPI(szWindowPlacement, "flags", wp.flags);
	APP_WPI(szWindowPlacement, "showCmd", wp.showCmd);

	APP_WPI(szWindowPlacement, "ptMinPosition.x", wp.ptMinPosition.x);
	APP_WPI(szWindowPlacement, "ptMinPosition.y", wp.ptMinPosition.y);

	APP_WPI(szWindowPlacement, "ptMaxPosition.x", wp.ptMaxPosition.x);
	APP_WPI(szWindowPlacement, "ptMaxPosition.y", wp.ptMaxPosition.y);

	APP_WPI(szWindowPlacement, "rcNormalPosition.left", wp.rcNormalPosition.left);
	APP_WPI(szWindowPlacement, "rcNormalPosition.right", wp.rcNormalPosition.right);
	APP_WPI(szWindowPlacement, "rcNormalPosition.top", wp.rcNormalPosition.top);
	APP_WPI(szWindowPlacement, "rcNormalPosition.bottom", wp.rcNormalPosition.bottom);
}
