// SnoopVw.cpp : implementation of the CSnoopView class
// See SnoopDat.cpp for other member functions of this class.
//

#include "stdafx.h"
#include "Snoop.h"

#include "SnoopDoc.h"
#include "SnoopVw.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/*static*/ CString CSnoopView::m_sStaticWindowText;

/////////////////////////////////////////////////////////////////////////////
// CSnoopView

IMPLEMENT_DYNCREATE(CSnoopView, CFormView)

BEGIN_MESSAGE_MAP(CSnoopView, CFormView)
	//{{AFX_MSG_MAP(CSnoopView)
	ON_EN_CHANGE(IDC_E_ADDRESS, OnChange)
	ON_BN_CLICKED(IDC_B_SNOOP, OnBSnoop)
	ON_BN_CLICKED(IDC_B_REFRESH, OnBRefresh)
	ON_CBN_SELCHANGE(IDC_C_CLASS, OnChange)
	ON_CBN_SELCHANGE(IDC_C_WINDOW, OnChange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSnoopView construction/destruction

CSnoopView::CSnoopView()
	: CFormView(CSnoopView::IDD)
{
	//{{AFX_DATA_INIT(CSnoopView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CSnoopView::~CSnoopView()
{
}

void CSnoopView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSnoopView)
	DDX_Control(pDX, IDC_B_SNOOP, m_buttSnoop);
	DDX_Control(pDX, IDC_E_ADDRESS, m_editAddress);
	DDX_Control(pDX, IDC_L_DATA, m_listData);
	DDX_Control(pDX, IDC_C_WINDOW, m_comboWindow);
	DDX_Control(pDX, IDC_C_CLASS, m_comboClass);
	//}}AFX_DATA_MAP
}

BOOL CSnoopView::PreCreateWindow(CREATESTRUCT& cs)
{
	return CFormView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CSnoopView diagnostics

#ifdef _DEBUG
void CSnoopView::AssertValid() const
{
	CFormView::AssertValid();
}

void CSnoopView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CSnoopDoc* CSnoopView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSnoopDoc)));
	return (CSnoopDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSnoopView message handlers

void CSnoopView::OnChange() 
{
	if (m_editAddress.GetWindowTextLength() > 1 &&
		m_comboClass.GetCurSel() >= 0 &&
		m_comboWindow.GetCurSel() >= 0)
	{
		m_buttSnoop.EnableWindow(TRUE);
	}
	else
	{
		m_buttSnoop.EnableWindow(FALSE);
	}

	m_listData.ResetContent();
}

void CSnoopView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	
	FillClassCombo();
	FillWindowCombo();
	
	OnChange();
	m_editAddress.LimitText(10);
	//m_editAddress.SetWindowText("0012fe68");
}

void CSnoopView::OnBRefresh() 
{
	FillWindowCombo();
}
